---
apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ .Release.Name }}-filelog
data:
  collector.yaml: |
    extensions:
      health_check:
        endpoint: "0.0.0.0:13133"
      file_storage:
        directory: /var/lib/otelcol
        timeout: 1s
        compaction:
          on_start: true
          directory: /var/lib/otelcol
    receivers:
      filelog/kubernetes:
        include:
          - /var/log/pods/*/*/*.log
        exclude:
          - /var/log/pods/*/otel-collector/*.log
        start_at: beginning
        include_file_path: true
        include_file_name: false
        storage: file_storage
        operators:
          - id: container-parser
            type: container
    processors:
      memory_limiter:
        check_interval: 1s
        limit_percentage: 80
        spike_limit_percentage: 25
      k8sattributes:
        auth_type: "serviceAccount"
        passthrough: false
        wait_for_metadata: true
        filter:
          node_from_env_var: KUBE_NODE_NAME
        extract:
          metadata:
            - k8s.pod.name
            - k8s.pod.uid
            - k8s.deployment.name
            - k8s.namespace.name
            - k8s.node.name
            - k8s.pod.start_time
            - container.id
            - k8s.container.name
          labels:
            - tag_name: service.name
              key: app.kubernetes.io/name
              from: pod
            - tag_name: cloud.region
              key: topology.kubernetes.io/region
              from: node
            - tag_name: cloud.availability_zone
              key: topology.kubernetes.io/zone
              from: node
        pod_association:
          - sources:
              - from: resource_attribute
                name: k8s.pod.uid
      batch:
        timeout: 5s
        send_batch_size: 50000
    exporters:
      otlp:
        endpoint: {{ .Release.Name }}-exporter.{{ .Release.Namespace }}.svc.cluster.local:4318
        tls:
          insecure: false
          ca_file: /egress-tls/ca.crt
          cert_file: /egress-tls/tls.crt
          key_file: /egress-tls/tls.key
    service:
      telemetry:
        logs:
          level: "warn"
      pipelines:
        logs:
          receivers: [filelog/kubernetes]
          processors: [memory_limiter, k8sattributes, batch]
          exporters: [otlp]
      extensions: [health_check, file_storage]
